import { Plugin } from "@webiny/plugins";
import { Context } from "@webiny/api/types";
import { ElasticsearchIndexRequestBody } from "@webiny/api-elasticsearch/types";
export interface CreateElasticsearchIndexTaskPluginIndex {
    index: string;
    settings?: Partial<ElasticsearchIndexRequestBody>;
}
export interface CreateElasticsearchIndexTaskPluginConfigParams<C extends Context> {
    context: C;
    tenant: string;
    locale: string;
}
export interface CreateElasticsearchIndexTaskPluginConfig<C extends Context> {
    name?: string;
    getIndexList(params: CreateElasticsearchIndexTaskPluginConfigParams<C>): Promise<CreateElasticsearchIndexTaskPluginIndex[]>;
}
export declare class CreateElasticsearchIndexTaskPlugin<C extends Context> extends Plugin {
    static readonly type: string;
    private readonly config;
    constructor(config: CreateElasticsearchIndexTaskPluginConfig<C>);
    getIndexList(params: CreateElasticsearchIndexTaskPluginConfigParams<C>): Promise<CreateElasticsearchIndexTaskPluginIndex[]>;
}
export declare const createElasticsearchIndexTaskPlugin: <C extends Context>(config: CreateElasticsearchIndexTaskPluginConfig<C>) => CreateElasticsearchIndexTaskPlugin<C>;
